#ifndef _d_file_h_
#define _d_file_h_
#include "file.h"
#include "scrollba.h"
#include "Keyboard.h"

//diplayed_file class
class D_File :public File 
{
    public:
        D_File(char *filename, int mode,char * commentchar, int x1, int y1, int x2, int y2);
        ~D_File();

        //scroll  up or down
        int scroll_lines(int lines);

        //scroll left or right
        int scroll_chars(int characters);

        //scroll to line
        int scroll_to(int line);

        //jump to line
        int jump_to(int line);

        void jump_to_char(int _char);
        void jump_to_eol(); //jumps to end of current line
        //set the color of a line
        void set_color(int line, int color);

        //refreshes the display
        void refresh();

        //returns the current top line
        int curline();

        //returns the height of the current display
        int dis_height();

        // this inserts a line above line number
        void insert_line(int number, char const *line);

        void delete_line(int number);


    private:
        //the color of each line, initialised to 7
        int *line_color;
        //coordinates in file
        int line_pos;
        int char_pos;
        //some buffers for string manipulations
        char *line_buffer;
        char *clear_line;

        //coordinates of viewport
        int col;
        int row;
        int width;
        int height;

        //scrollbars
        // ik heb een pointer gebruikt omdat ik de scrollbar
        // pas wil initialiseren nadat de file is ingelezen
        Scrollbar *vscroll;
};


#endif
