#include "screen.h"
Screen::Screen()
    {
    if (!number_of_objs)
    {
        allegro_init();
        if (set_gfx_mode(GFX_AUTODETECT, 640, 400, 0, 0) < 0)
        {
            if (set_gfx_mode(GFX_VESA1, 640, 400, 0, 0) < 0)
            {
                fprintf(stderr,"Unable to switch to graphics mode\n%s\n",allegro_error);
                exit(1);
            }
        }
        buffer = create_bitmap(800, 600);
        clear(buffer);
    }
    number_of_objs++;

}

int Screen::number_of_objs = 0;
int Screen::width = 80;
int Screen::height =50;
BITMAP *Screen::buffer;

int Screen::screenheight()
{
    return height;
}

int Screen::screenwidth()
{
    return width;
}

void Screen::remove_screen_now()
{
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        destroy_bitmap(buffer);
}

Screen::~Screen()
{
    number_of_objs--;
    if (!number_of_objs)
    {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        destroy_bitmap(buffer);
    }
}

void Screen::update(int x1,int y1,int x2,int y2)
{
    int tmp;
    if (x2 < x1)
    {
        tmp = x1;
        x1 = x2;
        x2 = tmp;
    }
    if (y2 < y1)
    {
        tmp = y1;
        y1 = y2;
        y2 = tmp;
    }
    blit(buffer, screen, (x1 - 1) * 8, (y1 - 1) * 8, (x1 - 1) * 8, (y1 - 1) * 8,(x2 - x1 + 1) * 8,(y2 - y1 + 1) * 8);
}

void Screen::print(int x, int y, int color, char *string)
{
    text_mode(color / 16);
    color %= 16;
    textout(buffer, fnt_0, string, 8 * (x - 1), 8 * (y - 1), color);
}

void Screen::clear_screen()
{
    clear(screen);
    clear(buffer);
}

void Screen::box(int x1, int y1, int x2, int y2, int color)
{
    filledbox(x1, y1, x2,y2, color);
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    rectfill(buffer, 8 * (x1 ), 8 * (y1 ), 8 * (x2 - 1) - 1, 8 * (y2 - 1) - 1, 0);
}

void Screen::box8(int x1, int y1, int x2, int y2, int color)
{
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    rect(buffer, x1, y1, x2, y2, color);
}

void Screen::filledbox(int x1, int y1, int x2, int y2, int color)
{
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    filledbox8(8 * (x1 - 1), 8 * (y1 - 1), 8 * x2 - 1, 8 * y2 - 1, color);
}

void Screen::filledbox8(int x1, int y1, int x2, int y2, int color)
{
    int swptmp;
    if (x1 > x2)
    {
        swptmp = x1;
        x1 = x2;
        x2 = swptmp;
    }
    if (y1 > y2)
    {
        swptmp = y1;
        y1 = y2;
        y2 = swptmp;
    }
    rect(buffer, x1, y1, x2, y2, 4);
    rect(buffer, x1 + 1, y1 + 1, x2, y2, 8);
                                
    rectfill(buffer, x1 + 1, y1 + 1, x2 - 1, y2 - 1, color);
}
