
#include "keyboard.h"
#include <time.h>

//extern void screensaver();

Keyboard::Keyboard()
{
    if (!number_of_instances)
    {
        for (int i=0;i<KEYBOARD_BUFFERSIZE;i++)
            buffer[i] = 0;
    }
    number_of_instances++;
}

Keyboard::~Keyboard()
{
    number_of_instances--;
}

int Keyboard::readkey()
{
    int retvalue;
    retvalue = buffer[tail];
    buffer[tail] = 0;
    if (retvalue)
        tail++;

    tail %=KEYBOARD_BUFFERSIZE;
    /*
        gotoxy(20,20);
        printf("readkey-h%3d bh%3d t%3d bt%3d-",head,buffer[head],tail,buffer[tail]);
        fflush(stdout);
        gotoxy(20,1);
        printf("-%3d-%3d-%3d-%3d-    ",buffer[0],buffer[1],buffer[2],buffer[3]);
        gotoxy(20,1);
        printf("-%3d-%3d-%3d-%3d-    ",buffer[0],buffer[1],buffer[2],buffer[3]);
        fflush(stdout);
        */
    return retvalue;
}

void Keyboard::update_keyboard_buffer()
{
    int 
        key;
    if (kbhit())
    {
        key = getch();
        if (!key) key = 256 + getch();
        
        //if (!buffer[(head+1) % KEYBOARD_BUFFERSIZE])
        if (!buffer[head])
        {
            buffer[head] = key;
            head++;
            head %= KEYBOARD_BUFFERSIZE;
        }
        /*
        gotoxy(25,25);
        printf("updbuf-h%3d bh%3d t%3d bt%3d-",head,buffer[head],tail,buffer[tail]);
        fflush(stdout);
        gotoxy(20,1);
        printf("-%3d-%3d-%3d-%3d-   ",buffer[0],buffer[1],buffer[2],buffer[3]);
        fflush(stdout);
          */
    }
}

int Keyboard::wait_key_pressed()
{



    int retvalue = 0;




//    int startclock = clock();
    while (!retvalue)
    {
        retvalue = readkey();
        update_keyboard_buffer();
//        if ((clock()/CLOCKS_PER_SEC - startclock) > 1)
//            screensaver();
    }
    return retvalue;
}

int Keyboard::number_of_instances = 0;
int Keyboard::head = 0;
int Keyboard::tail = 0;
int Keyboard::buffer[KEYBOARD_BUFFERSIZE];
