#include "scrollba.h"
#include "macros.h"

Scrollbar::Scrollbar()
{
    perror("Scrollbar:: no dimensions given");
}

Scrollbar::Scrollbar(int _screen_length, int _real_length, int x_upper_left, int y_upper_left, int _orientation)
{
    screen_length = _screen_length;
    real_length = _real_length;
    x = x_upper_left;
    y = y_upper_left;
    orientation = _orientation;
    position = 0;
    draw();
}

int Scrollbar::shift_to(int pos)
{
    if (pos < 0) 
        pos = 0;
    if (pos > real_length) 
        pos = real_length;
    position = pos;
    draw();
    return pos;
}

void Scrollbar::draw()
{
    int drawposition;
    drawposition = (int)(((double)position / real_length) * (screen_length - 3) * 8);
    if (orientation == HORIZONTAL)
    {
        filledbox(x + 1, y, x + screen_length - 2, y, SCROLL_BACK_COLOR);
        filledbox(x, y, x, y, SCROLL_END_COLOR);
        filledbox(x + screen_length - 1, y, x + screen_length - 1, y , SCROLL_END_COLOR);
        filledbox8(8 * (x - 1) + drawposition + 1, 8 * (y - 1), 8 * x + drawposition + 8, 8 * y, SCROLL_BLOCK_COLOR);
    }
    else
    {
        filledbox(x, y + 1, x, y + screen_length - 2, SCROLL_BACK_COLOR);
        filledbox(x, y, x, y, SCROLL_END_COLOR);
        filledbox(x, y + screen_length - 1, x, y + screen_length - 1, SCROLL_END_COLOR);
        filledbox8(8 * (x - 1) , 8 * y + drawposition, (8 * x) - 1 , 8 * y + drawposition + 7, SCROLL_BLOCK_COLOR);
    }

}

void Scrollbar::reset_real_length(int newlength)
{
    real_length = newlength;
    draw();
}
